define([
    'jquery',
    'domReady',
    './url',
    'jquery/ui',
    'underscore'
], function ($, domReady, url) {
    'use strict';

    $.widget('mage.filobluAjaxReloader', {
        filter_ajax_request: function (ajaxUrl) {

            url._removeParams(ajaxUrl, url.paramsToRemove);

            $.ajax({
                url: ajaxUrl,
                dataType: 'json',
                data: {
                    is_ajax: 1
                },
                beforeSend: function (xhr) {
                    $('body').trigger('processStart');
                }

            }).done(function (data) {

                $.each(data, function (key, value) {

                    var multipleSelectors = key.split(",");

                    $.each(multipleSelectors, function (keySingle, valueSingle) {
                        $(valueSingle).replaceWith($(value).filter(valueSingle).first());
                    });

                    $(key).trigger('contentUpdated');

                });

                $('body').trigger('processStop');

                if (!_.isUndefined(window.FiloBlu.ajaxlayerednavigationCategoryPushState)) {
                    $.mage.filobluProductListToolbarForm()._setCurrentUrl(ajaxUrl);
                }

                $(window).trigger('catalogUpdated');

            }).fail(function () {
                $('body').trigger('processStop');
            });
        }
    });

    domReady(function () {
        if (!_.isUndefined(window.FiloBlu.filterElements)) {
            $('body').on("click", window.FiloBlu.filterElements, function (e) {
                e.preventDefault();
                var url;
                url = $(this).attr('href');
                $.mage.filobluAjaxReloader().filter_ajax_request(url);
            });
        }
    });

    return $.mage.filobluAjaxReloader;

});
